"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  EthereumInjectedWallet: () => EthereumInjectedWallet,
  EvmWalletsWithStarknetFeatures: () => EvmWalletsWithStarknetFeatures,
  RosettanetAccount: () => RosettanetAccount,
  StarknetWalletApi: () => StarknetWalletApi,
  encodeMethod: () => encodeMethod,
  encodeParameters: () => encodeParameters,
  generateCanonicalSignature: () => generateCanonicalSignature,
  generateFullSignature: () => generateFullSignature,
  getStarknetAddress: () => getStarknetAddress,
  isEVMWallet: () => isEVMWallet,
  isEthereumWindowObject: () => isEthereumWindowObject,
  parseSignature: () => parseSignature,
  prepareMulticallCalldata: () => prepareMulticallCalldata,
  rosettanetWallet: () => rosettanetConnect_exports,
  types: () => types_exports
});
module.exports = __toCommonJS(index_exports);

// src/types/index.ts
var types_exports = {};
__export(types_exports, {
  BLOCK_STATUS: () => BLOCK_STATUS,
  ETHEREUM_CHAIN_PREFIX: () => ETHEREUM_CHAIN_PREFIX,
  STARKNET_CHAIN_PREFIX: () => STARKNET_CHAIN_PREFIX,
  TX_STATUS: () => TX_STATUS,
  TX_TYPE: () => TX_TYPE
});
var ETHEREUM_CHAIN_PREFIX = "eip155:";
var STARKNET_CHAIN_PREFIX = "starknet:";
var TX_STATUS = /* @__PURE__ */ ((TX_STATUS2) => {
  TX_STATUS2["CREATED"] = "CREATED";
  TX_STATUS2["PENDING"] = "PENDING";
  TX_STATUS2["INCLUDED"] = "INCLUDED";
  TX_STATUS2["SUCCESS"] = "SUCCESS";
  TX_STATUS2["FAILED"] = "FAILED";
  TX_STATUS2["DROPPED"] = "DROPPED";
  TX_STATUS2["REPLACED"] = "REPLACED";
  return TX_STATUS2;
})(TX_STATUS || {});
var BLOCK_STATUS = /* @__PURE__ */ ((BLOCK_STATUS2) => {
  BLOCK_STATUS2["PENDING"] = "PENDING";
  BLOCK_STATUS2["INCLUDED"] = "INCLUDED";
  BLOCK_STATUS2["CONFIRMED"] = "CONFIRMED";
  BLOCK_STATUS2["FINALIZED"] = "FINALIZED";
  BLOCK_STATUS2["REORGED"] = "REORGED";
  BLOCK_STATUS2["INVALID"] = "INVALID";
  return BLOCK_STATUS2;
})(BLOCK_STATUS || {});
var TX_TYPE = /* @__PURE__ */ ((TX_TYPE2) => {
  TX_TYPE2["TRANSFER"] = "TRANSFER";
  TX_TYPE2["CONTRACT_CREATION"] = "CONTRACT_CREATION";
  TX_TYPE2["CONTRACT_CALL"] = "CONTRACT_CALL";
  TX_TYPE2["DELEGATECALL"] = "DELEGATECALL";
  TX_TYPE2["STATICCALL"] = "STATICCALL";
  TX_TYPE2["EIP1559"] = "EIP1559";
  TX_TYPE2["LEGACY"] = "LEGACY";
  TX_TYPE2["CANCEL"] = "CANCEL";
  TX_TYPE2["SELFDESTRUCT"] = "SELFDESTRUCT";
  return TX_TYPE2;
})(TX_TYPE || {});

// src/calldata/helpers.ts
function padLeftTo32Bytes(input) {
  const length = input.length % 32 ? input.length + 32 - input.length % 32 : input.length;
  const result = new Uint8Array(length);
  result.set(input, result.length - input.length);
  return result;
}
function padRightTo32Bytes(input) {
  const length = input.length % 32 ? input.length + 32 - input.length % 32 : input.length;
  const result = new Uint8Array(length);
  result.set(input, 0);
  return result;
}
function concatenateBytes(source) {
  return new Uint8Array(source.flatMap((x) => [...x]));
}
function padAndLengthPrefix(source) {
  const length = source.length;
  const padded = padRightTo32Bytes(source);
  return concatenateBytes([integerToBytes(length), padded]);
}
function encodeDynamicData(encodedData) {
  let staticBytesSize = 0;
  for (let encodedParameter of encodedData) {
    if (encodedParameter.isDynamic) staticBytesSize += 32;
    else staticBytesSize += encodedParameter.bytes.length;
  }
  const staticBytes = [];
  const dynamicBytes = [];
  for (let encodedParameter of encodedData) {
    if (encodedParameter.isDynamic) {
      const dynamicBytesAppendedSoFar = dynamicBytes.reduce(
        (total, bytes) => total += bytes.length,
        0
      );
      staticBytes.push(integerToBytes(staticBytesSize + dynamicBytesAppendedSoFar));
      dynamicBytes.push(encodedParameter.bytes);
    } else {
      staticBytes.push(encodedParameter.bytes);
    }
  }
  return concatenateBytes([...staticBytes, ...dynamicBytes]);
}
function isEncodableArray(maybe) {
  return Array.isArray(maybe);
}
function integerToBytes(value, byteWidth = 32, signed = false) {
  return signed ? signedToBytes(value, byteWidth) : unsignedToBytes(value, byteWidth);
}
function unsignedToBytes(value, byteWidth = 32) {
  if (typeof value === "number") value = BigInt(value);
  const bits = byteWidth * 8;
  if (value >= 2n ** BigInt(bits) || value < 0n)
    throw new Error(`Cannot fit ${value} into a ${bits}-bit unsigned integer.`);
  const result = new Uint8Array(byteWidth);
  for (let i = 0; i < byteWidth; ++i) {
    result[i] = Number(value >> BigInt(bits - i * 8 - 8) & 0xffn);
  }
  return result;
}
function signedToBytes(value, byteWidth = 32) {
  if (typeof value === "number") value = BigInt(value);
  const bits = byteWidth * 8;
  if (value >= 2n ** (BigInt(bits) - 1n) || value < -(2n ** (BigInt(bits) - 1n)))
    throw new Error(`Cannot fit ${value} into a ${bits}-bit signed integer.`);
  const unsignedValue = twosComplement(value, bits);
  return unsignedToBytes(unsignedValue);
}
function twosComplement(value, numberOfBits) {
  const mask = 2n ** (BigInt(numberOfBits) - 1n) - 1n;
  return (value & mask) - (value & ~mask);
}

// src/calldata/calldata.ts
function parseSignature(functionSignature) {
  const signatureMatcher = /^([a-zA-Z_][a-zA-Z0-9_]+)\((.*)\)$/;
  const matchedSignature = signatureMatcher.exec(functionSignature);
  if (matchedSignature === null)
    throw new Error(`${functionSignature} is not a valid Solidity function signature.`);
  const name = matchedSignature[1];
  const inputs = parseParameters(matchedSignature[2]);
  return { type: "function", name, inputs, outputs: [] };
}
function parseParameters(functionParameters) {
  const parameters = [];
  let remainingParameters = functionParameters.trim();
  while (remainingParameters.length !== 0) {
    let { parameterDescription, remaining } = extractNextParameter(remainingParameters);
    remainingParameters = remaining;
    parameters.push(parameterDescription);
  }
  return parameters.map((x, i) => ({ ...x, name: x.name || `arg${i}` }));
}
function extractNextParameter(functionParameters) {
  let nesting = 0;
  let typeAndName = "";
  for (const character of functionParameters) {
    if (character === "(") ++nesting;
    if (character === ")") --nesting;
    if (nesting < 0)
      throw new Error(
        `${functionParameters} does not have matching number of open and close parenthesis`
      );
    if (nesting > 0) {
      typeAndName += character;
      continue;
    }
    if (character === ",") break;
    typeAndName += character;
  }
  const typeAndNameMatch = /^\s*(.+?)\s*(?:\s([a-zA-Z_][a-zA-Z0-9_]*))?\s*$/.exec(typeAndName);
  if (typeAndNameMatch === null)
    throw new Error(`${typeAndNameMatch} is not a valid parameter/name pair.`);
  let parameterType = typeAndNameMatch[1];
  let components = void 0;
  if (parameterType.startsWith("(")) {
    const tupleTypes = parameterType.slice(1, parameterType.lastIndexOf(")"));
    parameterType = `tuple${parameterType.slice(tupleTypes.length + 2)}`;
    components = parseParameters(tupleTypes);
  }
  const parameterName = typeAndNameMatch[2] || "";
  let remaining = functionParameters.slice(typeAndName.length);
  if (remaining.startsWith(",")) remaining = remaining.slice(1);
  remaining = remaining.trim();
  const parameterDescription = {
    name: parameterName,
    type: parameterType,
    components
  };
  return { parameterDescription, remaining };
}
function generateFullSignature(functionDescription) {
  return `${functionDescription.name}(${toFullParameters(functionDescription.inputs)})`;
}
function generateCanonicalSignature(functionDescription) {
  return `${functionDescription.name}(${toCanonicalParameters(functionDescription.inputs)})`;
}
function toFullParameters(parameters) {
  return parameters.map(toFullParameter).join(", ");
}
function toCanonicalParameters(parameters) {
  return parameters.map(toCanonicalParameter).join(",");
}
function toFullParameter(parameter) {
  if (parameter.type.startsWith("tuple")) {
    if (parameter.components === void 0)
      throw new Error(
        `Encountered a 'tuple' type that had no components.  Did you mean to include an empty array?`
      );
    return `(${toFullParameters(parameter.components)})${parameter.type.slice("tuple".length)} ${parameter.name}`;
  } else {
    return `${parameter.type} ${parameter.name}`;
  }
}
function toCanonicalParameter(parameter) {
  if (parameter.type.startsWith("tuple")) {
    if (parameter.components === void 0)
      throw new Error(
        `Encountered a 'tuple' type that had no components.  Did you mean to include an empty array?`
      );
    return `(${toCanonicalParameters(parameter.components)})${parameter.type.slice("tuple".length)}`;
  } else {
    return parameter.type;
  }
}
function encodeMethod(first, second, parameters) {
  if (typeof first === "number")
    return encodeMethodWithSelector(
      first,
      second,
      parameters
    );
  else if (typeof second === "string") return encodeMethodWithSignature(first, second, parameters);
  else return encodeMethodWithDescription(first, second, parameters);
}
async function encodeMethodWithDescription(keccak256, functionDescription, parameters) {
  const canonicalSignature = generateCanonicalSignature(functionDescription);
  const canonicalSignatureHash = await keccak256(new TextEncoder().encode(canonicalSignature));
  const functionSelector = canonicalSignatureHash >> 224n;
  return encodeMethod(Number(functionSelector), functionDescription.inputs, parameters);
}
async function encodeMethodWithSignature(keccak256, functionSignature, parameters) {
  const functionDescription = parseSignature(functionSignature);
  return await encodeMethodWithDescription(keccak256, functionDescription, parameters);
}
function encodeMethodWithSelector(functionSelector, parameterDescriptions, parameters) {
  const encodedParameters = encodeParameters(parameterDescriptions, parameters);
  return new Uint8Array([...integerToBytes(functionSelector, 4), ...encodedParameters]);
}
function encodeParameters(descriptions, parameters) {
  if (descriptions.length !== parameters.length)
    throw new Error(
      `Number of provided parameters (${parameters.length}) does not match number of expected parameters (${descriptions.length})`
    );
  const encodedParameters = parameters.map(
    (nestedParameter, index) => encodeParameter(descriptions[index], nestedParameter)
  );
  return encodeDynamicData(encodedParameters);
}
function encodeParameter(description, parameter) {
  return tryEncodeFixedArray(description, parameter) || tryEncodeDynamicArray(description, parameter) || tryEncodeTuple(description, parameter) || tryEncodeDynamicBytes(description, parameter) || tryEncodeString(description, parameter) || tryEncodeBoolean(description, parameter) || tryEncodeNumber(description, parameter) || tryEncodeAddress(description, parameter) || tryEncodeFixedBytes(description, parameter) || tryEncodeFixedPointNumber(description) || tryEncodeFunction(description) || function() {
    throw new Error(`Unsupported parameter type ${description.type}`);
  }();
}
function tryEncodeFixedArray(description, parameter) {
  const match = /^(.*)\[(\d+)\]$/.exec(description.type);
  if (match === null) return null;
  const size = Number.parseInt(match[2]);
  if (!Array.isArray(parameter) || parameter.length !== size)
    throw new Error(
      `Can only encode a JavaScript 'array' of length ${size} into an EVM 'array' of length ${size}
${parameter}`
    );
  const nestedDescription = Object.assign({}, description, { type: match[1] });
  const encodedParameters = parameter.map(
    (nestedParameter) => encodeParameter(nestedDescription, nestedParameter)
  );
  const isDynamic = encodedParameters.some((x) => x.isDynamic);
  if (isDynamic) {
    return { isDynamic, bytes: encodeDynamicData(encodedParameters) };
  } else {
    return { isDynamic, bytes: concatenateBytes(encodedParameters.map((x) => x.bytes)) };
  }
}
function tryEncodeDynamicArray(description, parameter) {
  if (!description.type.endsWith("[]")) return null;
  if (!Array.isArray(parameter))
    throw new Error(`Can only encode a JavaScript 'array' into an EVM 'array'
${parameter}`);
  const nestedDescription = Object.assign({}, description, {
    type: description.type.substring(0, description.type.length - 2)
  });
  const encodedParameters = parameter.map(
    (nestedParameter) => encodeParameter(nestedDescription, nestedParameter)
  );
  const lengthBytes = integerToBytes(encodedParameters.length);
  return {
    isDynamic: true,
    bytes: concatenateBytes([lengthBytes, encodeDynamicData(encodedParameters)])
  };
}
function tryEncodeTuple(description, parameter) {
  if (description.type !== "tuple") return null;
  if (typeof parameter !== "object")
    throw new Error(
      `Can only encode a JavaScript 'object' or a JavaScript array into an EVM 'tuple'
${parameter}`
    );
  if (description.components === void 0 || description.components.length === 0) {
    return { isDynamic: false, bytes: new Uint8Array(0) };
  } else {
    const encodableTupleOrArray = parameter;
    const encodedComponents = description.components.map((component, index) => {
      const parameter2 = isEncodableArray(encodableTupleOrArray) ? encodableTupleOrArray[index] : encodableTupleOrArray[component.name];
      return encodeParameter(component, parameter2);
    });
    const isDynamic = encodedComponents.some((x) => x.isDynamic);
    return {
      isDynamic,
      bytes: isDynamic ? encodeDynamicData(encodedComponents) : concatenateBytes(encodedComponents.map((x) => x.bytes))
    };
  }
}
function tryEncodeDynamicBytes(description, parameter) {
  if (description.type !== "bytes") return null;
  if (!(parameter instanceof Uint8Array))
    throw new Error(`Can only encode a JavaScript 'Uint8Array' into EVM 'bytes'
${parameter}`);
  return { isDynamic: true, bytes: padAndLengthPrefix(parameter) };
}
function tryEncodeString(description, parameter) {
  if (description.type !== "string") return null;
  if (typeof parameter !== "string")
    throw new Error(`Can only encode a JavaScript 'string' into an EVM 'string'
${parameter}`);
  const encoded = new TextEncoder().encode(parameter);
  return { isDynamic: true, bytes: padAndLengthPrefix(encoded) };
}
function tryEncodeBoolean(description, parameter) {
  if (description.type !== "bool") return null;
  if (typeof parameter !== "boolean")
    throw new Error(`Can only encode JavaScript 'boolean' into EVM 'bool'
${parameter}`);
  const bytes = new Uint8Array(32);
  bytes.set([parameter ? 1 : 0], 31);
  return { isDynamic: false, bytes };
}
function tryEncodeNumber(description, parameter) {
  const match = /^(u?)int(\d*)$/.exec(description.type);
  if (match === null) return null;
  if (typeof parameter !== "bigint")
    throw new Error(
      `Can only encode a JavaScript 'bigint' into an EVM '${description.type}'
${parameter}`
    );
  const size = Number.parseInt(match[2]);
  if (size <= 0 || size > 256 || size % 8)
    throw new Error(`EVM numbers must be in range [8, 256] and must be divisible by 8.`);
  const signed = !match[1];
  if (!signed && parameter >= 2n ** BigInt(size))
    throw new Error(
      `Attempted to encode ${parameter} into a ${description.type}, but it is too big to fit.`
    );
  if (!signed && parameter < 0n)
    throw new Error(
      `Attempted to encode ${parameter} into a ${description.type}, but you cannot encode negative numbers into a ${description.type}.`
    );
  if (signed && parameter >= 2n ** BigInt(size - 1))
    throw new Error(
      `Attempted to encode ${parameter} into a ${description.type}, but it is too big to fit.`
    );
  if (signed && parameter < -(2n ** BigInt(size - 1)))
    throw new Error(
      `Attempted to encode ${parameter} into a ${description.type}, but it is too big (of a negative number) to fit.`
    );
  const bytes = integerToBytes(parameter, 32, signed);
  return { isDynamic: false, bytes };
}
function tryEncodeAddress(description, parameter) {
  if (description.type !== "address") return null;
  if (typeof parameter !== "bigint")
    throw new Error(`Can only encode JavaScript 'bigint' into EVM 'address'
${parameter}`);
  if (parameter > 0xffffffffffffffffffffffffffffffffffffffffn)
    throw new Error(
      `Attempted to encode 0x${parameter.toString(16)} into an EVM address, but it is too big to fit.`
    );
  if (parameter < 0n)
    throw new Error(
      `Attempted to encode ${parameter} into an EVM address, but addresses must be positive numbers.`
    );
  return { isDynamic: false, bytes: padLeftTo32Bytes(integerToBytes(parameter, 20)) };
}
function tryEncodeFixedBytes(description, parameter) {
  const match = /^bytes(\d+)$/.exec(description.type);
  if (match === null) return null;
  const size = Number.parseInt(match[1]);
  if (typeof parameter !== "bigint")
    throw new Error(`Can only encode JavaScript 'bigint' into EVM 'bytes${size}'
${parameter}`);
  if (parameter >= 2n ** BigInt(size * 8))
    throw new Error(
      `Attempted to encode 0x${parameter.toString(16)} into an EVM ${description.type}, but it is too big to fit.`
    );
  if (parameter < 0n)
    throw new Error(
      `Attempted to encode -0x${parameter.toString(16).slice(1)} into an EVM ${description.type}, but you cannot encode negative numbers into a ${description.type}.`
    );
  return { isDynamic: false, bytes: padRightTo32Bytes(integerToBytes(parameter, size)) };
}
function tryEncodeFixedPointNumber(description) {
  if (!/^u?fixed\d+x\d+$/.test(description.type)) return null;
  throw new Error(`Encoding into EVM type ${description.type} is not supported`);
}
function tryEncodeFunction(description) {
  if (description.type !== "function") return null;
  throw new Error(`Encoding into EVM type ${description.type} is not supported`);
}

// src/calldata/multicall.ts
function prepareMulticallCalldata(calls) {
  const functionDesc = parseSignature("multicall((uint256,uint256,uint256[])[])");
  const encodedParams = wireEncodeByteArray(
    encodeParameters(functionDesc.inputs, [
      calls.map((call2) => [
        BigInt(call2.contract_address),
        BigInt(call2.entry_point),
        [...call2.calldata.map((cd) => BigInt(cd))]
      ])
    ])
  );
  return encodedParams.replace("0x", "0x76971d7f");
}
function wireEncodeByteArray(bytes) {
  let result = "";
  for (let i = 0; i < bytes.length; ++i) {
    result += ("0" + bytes[i].toString(16)).slice(-2);
  }
  return `0x${result}`;
}

// src/calldata/getStarknetAddress.ts
var import_starknet = require("starknet");
async function getStarknetAddress(EthAddress, nodeUrl, rosettanetAddress) {
  if (!EthAddress || !/^0x[a-fA-F0-9]{40}$/.test(EthAddress)) {
    throw new Error("EthAddress is required");
  }
  if (!nodeUrl) {
    throw new Error("nodeUrl is required");
  }
  if (!rosettanetAddress) {
    throw new Error("rosettanetAddress is required");
  }
  const starknetProvider = new import_starknet.RpcProvider({
    nodeUrl
  });
  const rosettanetContractAddress = rosettanetAddress;
  const { abi: rosettanetContractAbi } = await starknetProvider.getClassAt(rosettanetContractAddress);
  if (rosettanetContractAbi === void 0) {
    throw new Error("no contract abi, check contract address");
  }
  const rosettanetContract = new import_starknet.Contract(
    rosettanetContractAbi,
    rosettanetContractAddress,
    starknetProvider
  );
  const starknetAddress = await rosettanetContract.get_starknet_address_with_fallback(EthAddress);
  return "0x" + starknetAddress.toString(16);
}

// src/account/rosettanetConnect.ts
var rosettanetConnect_exports = {};
__export(rosettanetConnect_exports, {
  accounts: () => accounts,
  call: () => call,
  clientVersion: () => clientVersion,
  estimateGas: () => estimateGas,
  gasPrice: () => gasPrice,
  getBalance: () => getBalance,
  getBlockByHash: () => getBlockByHash,
  getBlockByNumber: () => getBlockByNumber,
  getBlockNumber: () => getBlockNumber,
  getBlockTransactionCountByHash: () => getBlockTransactionCountByHash,
  getBlockTransactionCountByNumber: () => getBlockTransactionCountByNumber,
  getCode: () => getCode,
  getPermissions: () => getPermissions,
  getTransactionByHash: () => getTransactionByHash,
  getTransactionCount: () => getTransactionCount,
  getTransactionHashByBlockHashAndIndex: () => getTransactionHashByBlockHashAndIndex,
  getTransactionHashByBlockNumberAndIndex: () => getTransactionHashByBlockNumberAndIndex,
  getTransactionReceipt: () => getTransactionReceipt,
  personalSign: () => personalSign,
  requestAccounts: () => requestAccounts,
  requestChainId: () => requestChainId,
  sendTransaction: () => sendTransaction,
  signMessage: () => signMessage,
  switchRosettanetChain: () => switchRosettanetChain,
  syncing: () => syncing,
  watchAsset: () => watchAsset
});
function requestAccounts(ewo) {
  return ewo.request({ method: "eth_requestAccounts" });
}
function watchAsset(ewo, asset) {
  return ewo.request({ method: "wallet_watchAsset", params: [asset] });
}
function requestChainId(ewo) {
  return ewo.request({ method: "eth_chainId" });
}
function sendTransaction(ewo, tx) {
  return ewo.request({ method: "eth_sendTransaction", params: [tx] });
}
function switchRosettanetChain(ewo, chainId) {
  return ewo.request({
    method: "wallet_switchEthereumChain",
    params: [{ chainId }]
  });
}
function getPermissions(ewo) {
  return ewo.request({ method: "wallet_getPermissions" });
}
function personalSign(ewo, message, address) {
  return ewo.request({ method: "personal_sign", params: [message, address] });
}
function accounts(ewo) {
  return ewo.request({ method: "eth_accounts" });
}
function clientVersion(ewo) {
  return ewo.request({ method: "web3_clientVersion" });
}
function getBlockNumber(ewo) {
  return ewo.request({ method: "eth_blockNumber" });
}
function call(ewo, tx) {
  return ewo.request({ method: "eth_call", params: [tx] });
}
function estimateGas(ewo, tx) {
  return ewo.request({ method: "eth_estimateGas", params: [tx] });
}
function gasPrice(ewo) {
  return ewo.request({ method: "eth_gasPrice" });
}
function getBalance(ewo, address, block = "latest") {
  return ewo.request({ method: "eth_getBalance", params: [address, block] });
}
function getBlockByHash(ewo, blockHash, hydratedTx = false) {
  return ewo.request({ method: "eth_getBlockByHash", params: [blockHash, hydratedTx] });
}
function getBlockByNumber(ewo, blockNumber, hydratedTx = false) {
  return ewo.request({ method: "eth_getBlockByNumber", params: [blockNumber, hydratedTx] });
}
function getBlockTransactionCountByHash(ewo, blockHash) {
  return ewo.request({ method: "eth_getBlockTransactionCountByHash", params: [blockHash] });
}
function getBlockTransactionCountByNumber(ewo, blockNumber) {
  return ewo.request({ method: "eth_getBlockTransactionCountByNumber", params: [blockNumber] });
}
function getCode(ewo, address, block = "latest") {
  return ewo.request({ method: "eth_getCode", params: [address, block] });
}
function getTransactionHashByBlockHashAndIndex(ewo, blockHash, index) {
  return ewo.request({
    method: "eth_getTransactionByBlockHashAndIndex",
    params: [blockHash, index]
  });
}
function getTransactionHashByBlockNumberAndIndex(ewo, blockNumber, index) {
  return ewo.request({
    method: "eth_getTransactionByBlockNumberAndIndex",
    params: [blockNumber, index]
  });
}
function getTransactionByHash(ewo, txHash) {
  return ewo.request({ method: "eth_getTransactionByHash", params: [txHash] });
}
function getTransactionCount(ewo, address, block = "latest") {
  return ewo.request({ method: "eth_getTransactionCount", params: [address, block] });
}
function getTransactionReceipt(ewo, txHash) {
  return ewo.request({ method: "eth_getTransactionReceipt", params: [txHash] });
}
function syncing(ewo) {
  return ewo.request({ method: "eth_syncing" });
}
function signMessage(ewo, message, address) {
  return ewo.request({ method: "eth_signTypedData_v4", params: [address, message] });
}

// src/account/rosettanetAccount.ts
var import_starknet2 = require("starknet");

// src/utils/validateCallParams.ts
var validateCallParams = (value) => {
  return Array.isArray(value) && value.every(
    (item) => typeof item === "object" && item !== null && !Array.isArray(item) && "contractAddress" in item && "entrypoint" in item && "calldata" in item
  );
};

// src/account/rosettanetAccount.ts
var RosettanetAccount = class _RosettanetAccount extends import_starknet2.Account {
  walletProvider;
  constructor(providerOrOptions, walletProvider, cairoVersion, address = "") {
    super(providerOrOptions, address, "", cairoVersion);
    this.walletProvider = walletProvider;
    if (!address.length) {
      console.warn(
        "@deprecated Use static method WalletAccount.connect or WalletAccount.connectSilent instead. Constructor {@link WalletAccount.(format:2)}."
      );
      requestAccounts(this.walletProvider).then(([accountAddress]) => {
        this.address = accountAddress.toLowerCase();
      });
    }
  }
  /**
   * Send transaction to the wallet.
   * @param params Ethereum transaction object.
   * @returns Transaction hash.
   */
  sendTransactionRosettanet(params) {
    return sendTransaction(this.walletProvider, params);
  }
  /**
   * Request the current chain ID from the wallet.
   * @returns The current Wallet Chain ID.
   */
  chainIdRosettanet() {
    return requestChainId(this.walletProvider);
  }
  /**
   * Sign typed data using the wallet. Uses personal_sign method.
   * @param message The typed data to sign.
   * @param address The wallet address to sign.
   * @returns Signatures as strings.
   */
  personalSignRosettanet(message, address) {
    return personalSign(this.walletProvider, message, address);
  }
  /**
   * Request connected accounts
   * @returns connected accounts addresses
   */
  accountsRosettanet() {
    return accounts(this.walletProvider);
  }
  /**
   * Request latest block number in Starknet
   * @returns latest block number in hexadecimal format
   */
  blockNumberRosettanet() {
    return getBlockNumber(this.walletProvider);
  }
  /**
   * Call request.
   * @param tx Ethereum transaction object.
   * @returns Answer from called contract.
   */
  callRosettanet(tx) {
    return call(this.walletProvider, tx);
  }
  /**
   * Estimated gas fee for the transaction.
   * @param tx Ethereum transaction object.
   * @returns Estimated gas amount.
   */
  estimateGasRosettanet(tx) {
    return estimateGas(this.walletProvider, tx);
  }
  /**
   * Latest gas price in network.
   * @returns Latest gas price.
   */
  gasPriceRosettanet() {
    return gasPrice(this.walletProvider);
  }
  /**
   * STRK balance of given address.
   * @param address Address to check balance.
   * @param block Block number or hash. (optional)
   * @returns STRK balance.
   */
  getBalanceRosettanet(address, block = "latest") {
    return getBalance(this.walletProvider, address, block);
  }
  /**
   * Block by given block hash.
   * @param blockHash Block hash.
   * @param hydratedTx Hydrated transactions (optional)
   * @returns Block by given block hash.
   */
  getBlockByHashRosettanet(blockHash, hydratedTx = false) {
    return getBlockByHash(this.walletProvider, blockHash, hydratedTx);
  }
  /**
   * Block by given block number.
   * @param blockNumber Block number or block tag.
   * @param hydratedTx Hydrated transactions (optional)
   * @returns Block by given block number.
   */
  getBlockByNumberRosettanet(blockNumber, hydratedTx = false) {
    return getBlockByNumber(this.walletProvider, blockNumber, hydratedTx);
  }
  /**
   * Transaction count of given block hash.
   * @param blockHash Block hash.
   * @returns Transaction count of given block hash.
   */
  getBlockTransactionCountByHashRosettanet(blockHash) {
    return getBlockTransactionCountByHash(this.walletProvider, blockHash);
  }
  /**
   * Transaction count of given block number.
   * @param blockNumber Block number or block tag..
   * @returns Transaction count of given block number.
   */
  getBlockTransactionCountByNumberRosettanet(blockNumber) {
    return getBlockTransactionCountByNumber(this.walletProvider, blockNumber);
  }
  getCodeRosettanet(address, block = "latest") {
    return getCode(this.walletProvider, address, block);
  }
  getTransactionHashByBlockHashAndIndexRosettanet(blockHash, index) {
    return getTransactionHashByBlockHashAndIndex(this.walletProvider, blockHash, index);
  }
  getTransactionHashByBlockNumberAndIndexRosettanet(blockNumber, index) {
    return getTransactionHashByBlockNumberAndIndex(this.walletProvider, blockNumber, index);
  }
  getTransactionByHashRosettanet(txHash) {
    return getTransactionByHash(this.walletProvider, txHash);
  }
  /**
   * Transaction count of given address.
   * @param address address.
   * @returns Transaction count of given address.
   */
  getTransactionCountRosettanet(address, block = "latest") {
    return getTransactionCount(this.walletProvider, address, block);
  }
  /**
   * Transaction receipt of given transaction hash.
   * @param txHash address.
   * @returns Transaction receipt of given transaction hash.
   */
  getTransactionReceiptRosettanet(txHash) {
    return getTransactionReceipt(this.walletProvider, txHash);
  }
  // WALLET ACCOUNT METHODS
  requestAccounts() {
    return requestAccounts(this.walletProvider);
  }
  /**
   * Request Permission for wallet account
   * @returns allowed accounts addresses
   */
  getPermissions() {
    if (this.walletProvider.name === "Coinbase Wallet") {
      throw new Error("Get permissions Method not found in Coinbase Wallet");
    }
    return getPermissions(this.walletProvider);
  }
  switchStarknetChain(chainId) {
    return switchRosettanetChain(this.walletProvider, chainId);
  }
  /**
   * Request adding ERC20 Token to Wallet List
   * @param asset WatchAssetParameters
   * @returns boolean
   */
  watchAsset(asset) {
    return watchAsset(this.walletProvider, asset);
  }
  declare() {
    throw new Error("Declare Method not implemented in Rosettanet Account Class.");
  }
  deploy() {
    throw new Error("Deploy Method not implemented in Rosettanet Account Class.");
  }
  /**
   * Sign typed data using the wallet. Uses eth_signTypedData_v4 method.
   * @param message The typed data to sign.
   * @returns Signature as strings.
   */
  async signMessage(message) {
    const evmSignedHash = await signMessage(this.walletProvider, message, this.address);
    if (!evmSignedHash || evmSignedHash.length !== 132 && evmSignedHash.length !== 130) {
      throw new Error("Ethereum Signature error");
    }
    const signedHashWithoutPrefix = import_starknet2.encode.removeHexPrefix(evmSignedHash);
    const r = import_starknet2.cairo.uint256(import_starknet2.encode.addHexPrefix(signedHashWithoutPrefix.slice(0, 63)));
    const s = import_starknet2.cairo.uint256(import_starknet2.encode.addHexPrefix(signedHashWithoutPrefix.slice(64, 127)));
    const v = import_starknet2.encode.addHexPrefix(signedHashWithoutPrefix.slice(128, 130));
    if (v !== "0x1c" && v !== "0x1b") {
      throw new Error("Invalid Ethereum Signature");
    }
    return [
      import_starknet2.num.toHex(r.low),
      import_starknet2.num.toHex(r.high),
      import_starknet2.num.toHex(s.low),
      import_starknet2.num.toHex(s.high),
      import_starknet2.num.toHex(v)
    ];
  }
  async execute(calls) {
    if (validateCallParams(calls) === false) {
      throw new Error(
        "Invalid call parameter. Expected an array of objects. Rosettanet only supports multicall."
      );
    }
    const arrayCalls = calls.map((item) => [
      item.contractAddress,
      item.entrypoint,
      item.calldata
    ]);
    const txCalls = [].concat(arrayCalls).map((it) => {
      const entryPointValue = it[1];
      const entryPoint = entryPointValue.startsWith("0x") ? entryPointValue : import_starknet2.hash.getSelectorFromName(entryPointValue);
      return {
        contract_address: it[0],
        entry_point: entryPoint,
        calldata: it[2]
      };
    });
    const params = {
      calls: txCalls
    };
    const txData = prepareMulticallCalldata(params.calls);
    const txObject = {
      from: this.address,
      to: "0x0000000000000000000000004645415455524553",
      data: txData,
      value: "0x0"
    };
    const txHash = await sendTransaction(this.walletProvider, txObject);
    return { transaction_hash: txHash };
  }
  static async connect(provider, walletProvider, cairoVersion) {
    const [accountAddress] = await requestAccounts(walletProvider);
    return new _RosettanetAccount(provider, walletProvider, cairoVersion, accountAddress);
  }
  static async connectSilent(provider, walletProvider, cairoVersion) {
    const [accountAddress] = await requestAccounts(walletProvider);
    return new _RosettanetAccount(provider, walletProvider, cairoVersion, accountAddress);
  }
};

// src/wallet/discovery/evm-wallets.ts
var import_mipd = require("mipd");

// src/wallet/wallet-standard/evm-injected-wallet.ts
var import_features2 = require("@wallet-standard/features");

// src/wallet/wallet-standard/features.ts
var import_features = require("@wallet-standard/features");
var StarknetWalletApi = "starknet:walletApi";
var RequiredStarknetFeatures = [
  StarknetWalletApi,
  import_features.StandardConnect,
  import_features.StandardDisconnect,
  import_features.StandardEvents
];
function isEVMWallet(wallet) {
  const result = RequiredStarknetFeatures.every((feature) => feature in wallet.features);
  return result;
}

// src/utils/createEthTxObject.ts
var import_starknet3 = require("starknet");
function createEthTxObject(address, calls) {
  const arrayCalls = calls.map((item) => [
    item.contractAddress,
    item.entrypoint,
    item.calldata
  ]);
  const txCalls = [].concat(arrayCalls).map((it) => {
    const entryPointValue = it[1];
    const entryPoint = entryPointValue.startsWith("0x") ? entryPointValue : import_starknet3.hash.getSelectorFromName(entryPointValue);
    return {
      contract_address: it[0],
      entry_point: entryPoint,
      calldata: it[2]
    };
  });
  const params = {
    calls: txCalls
  };
  const txData = prepareMulticallCalldata(params.calls);
  const txObject = {
    from: address,
    to: "0x0000000000000000000000004645415455524553",
    data: txData,
    value: "0x0"
  };
  return txObject;
}

// src/wallet/wallet-standard/evm-injected-wallet.ts
var walletToEthereumRpcMap = {
  wallet_getPermissions: void 0,
  wallet_requestAccounts: "eth_requestAccounts",
  wallet_watchAsset: "wallet_watchAsset",
  wallet_addStarknetChain: void 0,
  wallet_switchStarknetChain: void 0,
  wallet_requestChainId: "eth_chainId",
  wallet_deploymentData: void 0,
  wallet_addInvokeTransaction: "eth_sendTransaction",
  wallet_addDeclareTransaction: void 0,
  wallet_signTypedData: "personal_sign",
  wallet_supportedSpecs: void 0,
  wallet_supportedWalletApi: void 0
};
var EthereumInjectedWallet = class {
  constructor(injected) {
    this.injected = injected;
    this.injected.on("accountsChanged", this.#onAccountsChanged.bind(this));
    this.injected.on("networkChanged", this.#onNetworkChanged.bind(this));
  }
  #listeners = {};
  #account = null;
  get version() {
    return "1.0.0";
  }
  get name() {
    return this.injected.name;
  }
  get icon() {
    return this.injected.icon;
  }
  get features() {
    return {
      [import_features2.StandardConnect]: {
        version: "1.0.0",
        connect: this.#connect.bind(this)
      },
      [import_features2.StandardDisconnect]: {
        version: "1.0.0",
        disconnect: this.#disconnect.bind(this)
      },
      [import_features2.StandardEvents]: {
        version: "1.0.0",
        on: this.#on.bind(this)
      },
      [StarknetWalletApi]: {
        version: "1.0.0",
        request: this.#request.bind(this),
        walletVersion: this.injected.version
      }
    };
  }
  get chains() {
    return [
      "eip155:1381192787"
      // Rosettanet Chain ID
    ];
  }
  get accounts() {
    if (this.#account) {
      return [
        {
          address: this.#account.address,
          publicKey: new Uint8Array(),
          chains: [this.#account.chain],
          features: []
        }
      ];
    }
    return [];
  }
  #connect = async () => {
    if (!this.#account) {
      const accounts2 = await this.#request({
        type: "wallet_requestAccounts"
      });
      if (accounts2.length === 0) {
        return { accounts: [] };
      }
      await this.#updateAccount(accounts2);
    }
    return { accounts: this.accounts };
  };
  #disconnect = async () => {
    this.#disconnected();
    return;
  };
  #on = (event, listener) => {
    if (!this.#listeners[event]) {
      this.#listeners[event] = [];
    }
    this.#listeners[event].push(listener);
    return () => this.#off(event, listener);
  };
  #emit(event, ...args) {
    if (!this.#listeners[event]) return;
    for (const listener of this.#listeners[event]) {
      listener.apply(null, args);
    }
  }
  #off(event, listener) {
    this.#listeners[event] = this.#listeners[event]?.filter(
      (existingListener) => listener !== existingListener
    );
  }
  #disconnected() {
    if (this.#account) {
      this.#account = null;
      this.#emit("change", { accounts: this.accounts });
    }
  }
  async #onAccountsChanged(accounts2) {
    if (!accounts2 || accounts2.length === 0) {
      this.#disconnected();
      return;
    }
    if (!this.#account) {
      return;
    }
    await this.#updateAccount(accounts2);
  }
  #onNetworkChanged(chainIdHex) {
    if (!chainIdHex || !this.#account) {
      this.#disconnected();
      return;
    }
    const chainId = Number.parseInt(chainIdHex, 16).toString();
    const chain = `eip155:${chainId}`;
    if (!this.chains.includes(chain)) {
      console.warn("Switched to unsupported chain:", chain);
    }
    this.#account.chain = chain;
    this.#emit("change", { accounts: this.accounts });
  }
  async #updateAccount(accounts2) {
    if (accounts2.length === 0) {
      return;
    }
    const [account] = accounts2;
    if (this.#account?.chain) {
      this.#account.address = account;
      this.#emit("change", { accounts: this.accounts });
    } else {
      const chain = await this.#getEthereumChain();
      this.#account = { address: account, chain };
      this.#emit("change", { accounts: this.accounts });
    }
  }
  #request = async (call2) => {
    const mappedMethod = walletToEthereumRpcMap[call2.type];
    if (!mappedMethod) {
      throw new Error(`Unsupported request type: ${call2.type}`);
    }
    if (mappedMethod === "eth_sendTransaction" && call2.params) {
      if (validateCallParams(call2.params) === false) {
        throw new Error(
          "Invalid call parameter. Expected an array of objects. Rosettanet only supports multicall."
        );
      }
      const txObject = createEthTxObject(this.#account?.address, call2.params);
      const ethPayload = {
        method: mappedMethod,
        params: [txObject]
      };
      return this.injected.request(ethPayload);
    }
    if (mappedMethod === "personal_sign" && call2.params) {
      const ethPayload = {
        method: mappedMethod,
        params: [this.#account?.address, call2.params]
      };
      return this.injected.request(ethPayload);
    }
    if (mappedMethod === "wallet_watchAsset" && call2.params) {
      const ethPayload = {
        method: mappedMethod,
        params: call2.params
      };
      return this.injected.request(ethPayload);
    }
    return this.injected.request({
      method: mappedMethod,
      params: call2.params ? [call2.params] : []
    });
  };
  async #getEthereumChain() {
    const chainIdHex = await this.#request({
      type: "wallet_requestChainId"
    });
    const chainId = Number.parseInt(chainIdHex, 16).toString();
    const chain = `eip155:${chainId}`;
    if (chainId !== "1381192787") {
      throw new Error("Invalid Rosettanet chain");
    }
    return chain;
  }
};

// src/wallet/discovery/evm-wallets.ts
async function EvmWalletsWithStarknetFeatures() {
  let Wallets = [];
  const store = (0, import_mipd.createStore)();
  const providers = store.getProviders();
  for (const wallet of providers) {
    if (wallet.info.rdns === "com.bitget.web3") {
      wallet.info.name = "Bitget Wallet via Rosettanet";
    } else if (wallet.info.rdns === "com.okex.wallet") {
      wallet.info.name = "OKX Wallet via Rosettanet";
    }
    const walletWithStarknetKeys = {
      ...wallet.provider,
      id: wallet.info.name,
      name: wallet.info.name,
      icon: wallet.info.icon,
      version: "1.0.0",
      on: wallet.provider.on,
      off: wallet.provider.removeListener
    };
    Wallets.push(new EthereumInjectedWallet(walletWithStarknetKeys));
  }
  return Wallets;
}
var ETHEREUM_WALLET_KEYS = ["sendAsync", "send", "request"];
function isEthereumWindowObject(wallet) {
  if (typeof wallet !== "object" || wallet === null) return false;
  return ETHEREUM_WALLET_KEYS.every((key) => key in wallet);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EthereumInjectedWallet,
  EvmWalletsWithStarknetFeatures,
  RosettanetAccount,
  StarknetWalletApi,
  encodeMethod,
  encodeParameters,
  generateCanonicalSignature,
  generateFullSignature,
  getStarknetAddress,
  isEVMWallet,
  isEthereumWindowObject,
  parseSignature,
  prepareMulticallCalldata,
  rosettanetWallet,
  types
});
//# sourceMappingURL=index.cjs.map